<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Chapter 11: Memory Allocation</title>
<link href="sx10h.html" rev=precedes>
<link href="sx11a.html" rel=precedes>
<link href="top.html" rev=subdocument>
</head>
<body>
<H1>Chapter 11: Memory Allocation</H1>

<p>In this chapter, we'll meet <TT>malloc</TT>,
C's dynamic memory allocation function,
and we'll cover dynamic memory allocation in some detail.
</p><p>As we begin doing dynamic memory allocation, we'll begin to see
(if we haven't seen it already)
what pointers can really be good for.
Many of the pointer examples in the previous chapter
(those which used pointers to access arrays)
didn't do all that much for us
that we couldn't have done
using arrays.
However,
when we begin doing dynamic memory allocation,
pointers are the only way to go,
because what <TT>malloc</TT> returns
is a pointer to the memory it gives us.
(Due to the equivalence between pointers and arrays,
though,
we will still be able to think of
dynamically allocated regions of storage as if they were arrays,
and even to use array-like subscripting notation on them.)
</p><p>You have to be careful with dynamic memory allocation.
<TT>malloc</TT> operates at a pretty ``low level'';
you will often find yourself having to do a certain amount of
work
to manage the memory it gives you.
If you don't keep accurate track
of the memory which <TT>malloc</TT> has given you,
and the pointers of yours which point to it,
it's all too easy to accidentally use a pointer
which points ``nowhere'',
with generally unpleasant results.

(The basic problem
is that if you assign a value to the location pointed to by a pointer:
<pre>
	*p = 0;
</pre>
and if the pointer <TT>p</TT> points ``nowhere'',

well actually it can be construed to point somewhere,
just not where you wanted it to,
and that ``somewhere'' is where the 0 gets written.
If the ``somewhere'' is memory
which is in use by some other part of your program,
or even worse,
if the operating system has not protected itself from you
and ``somewhere'' is in fact in use by the operating system,
things could get ugly.)

</p><p><a href="sx11a.html" rel=subdocument>11.1 Allocating Memory with <TT>malloc</TT></a></p>
<p><a href="sx11b.html" rel=subdocument>11.2 Freeing Memory</a></p>
<p><a href="sx11c.html" rel=subdocument>11.3 Reallocating Memory Blocks</a></p>
<p><a href="sx11d.html" rel=subdocument>11.4 Pointer Safety</a></p>
<hr>
<p>
Read sequentially:
<a href="sx10h.html" rev=precedes>prev</a>
<a href="sx11a.html" rel=precedes>next</a>
<a href="top.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
